import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.*;

public class Aufgabe1Test {
    private static final List<int[]> inputsV = new ArrayList<>();
    private static final List<int[]> inputsW = new ArrayList<>();
    private static final List<int[][]> inputsM = new ArrayList<>();

    private static final int[] v = {1, 2, 3};
    private static final int[] w = {4, 5, 6};
    private static final int[][] m = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}};
    private static final int[][] m2 = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}, {10, 11, 12}};


    static {
        Random rand = new Random(4711);
        while (inputsV.size() < 100) {
            int length = rand.nextInt(100);
            if (length > 0) {
                int[] v = new int[length];
                int[] w = new int[length];
                int[][] m = new int[length][length];
                for (int i = 0; i < v.length; i++) {
                    v[i] = rand.nextInt(100) - 50;
                    w[i] = rand.nextInt(100) - 50;
                    for (int j = 0; j < v.length; j++) {
                        m[i][j] = rand.nextInt(100) - 50;
                    }
                }
                inputsV.add(v);
                inputsW.add(w);
                inputsM.add(m);
            }
        }
    }

    private static Stream<Arguments> getTestInputArrays() {
        Stream.Builder<Arguments> sb = Stream.builder();
        for (int i = 0; i < inputsV.size(); i++) {
            sb.add(Arguments.of(inputsV.get(i), inputsW.get(i), inputsM.get(i)));
        }
        return sb.build();
    }

    @ParameterizedTest
    @MethodSource("getTestInputArrays")
    void add(int[] v, int[] w, int[][] m) {
        assertArrayEquals(Aufgabe1.add(v, w), Aufgabe1.add(w, v));
    }

    @Test
    void addExamples() {
        assertArrayEquals(new int[]{2, 4, 6}, Aufgabe1.add(v, v));
        assertArrayEquals(new int[]{8, 10, 12}, Aufgabe1.add(w, w));
        assertArrayEquals(new int[]{5, 7, 9}, Aufgabe1.add(v, w));
    }

    @ParameterizedTest
    @MethodSource("getTestInputArrays")
    void ssp(int[] v, int[] w, int[][] m) {
        assertTrue(Aufgabe1.ssp(v, v) >= 0);
        assertTrue(Aufgabe1.ssp(w, w) >= 0);
    }

    @Test
    void sspExamples() {
        assertEquals(14, Aufgabe1.ssp(v, v));
        assertEquals(77, Aufgabe1.ssp(w, w));
        assertEquals(32, Aufgabe1.ssp(v, w));
    }

    @Test
    void mulExamples() {
        assertArrayEquals(new int[]{14, 32, 50}, Aufgabe1.mul(m, v));
        assertArrayEquals(new int[]{14, 32, 50, 68}, Aufgabe1.mul(m2, v));
    }
}
