import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.*;
import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.*;

public class Aufgabe2Test {
    private static final List<List<Boolean>> inputs = new ArrayList<>();

    static {
        Random rand = new Random(4711);
        while (inputs.size() < 100) {
            Deque<Integer> stack = new ArrayDeque<>();
            int size = rand.nextInt(40);
            stack.push(size);
            List<Boolean> res = new ArrayList<>();
            while (!stack.isEmpty()) {
                int s = stack.pop();
                if (s > 0) {
                    int sizeL = rand.nextInt(s);
                    int sizeR = s - sizeL - 1;
                    stack.addFirst(sizeR);
                    stack.addFirst(sizeL);
                    res.add(true);
                } else {
                    res.add(false);
                }
            }
            inputs.add(res);
        }
    }

    private static boolean[] convL(List<Boolean> arr) {
        boolean[] r = new boolean[arr.size()];
        for (int i=0; i<arr.size();i++) r[i] = arr.get(i);
        return r;
    }

    private static Stream<Arguments> getMagicTestInputArrays() {
        return inputs.stream().map(x -> Arguments.of((Object) convL(x)));
    }

    private static Stream<Arguments> getNonMagicTestInputArrays() {
        int seed = Objects.hash(inputs);
        Random rand = new Random(seed);
        return inputs.stream().map(x -> {
            x.remove(rand.nextInt(x.size()));
            return Arguments.of((Object) convL(x));
        });
    }

    @ParameterizedTest
    @MethodSource("getMagicTestInputArrays")
    void magic(boolean[] input) {
        assertTrue(Aufgabe2.magic(input));
    }

    @ParameterizedTest
    @MethodSource("getNonMagicTestInputArrays")
    void notMagic(boolean[] input) {
        assertFalse(Aufgabe2.magic(input));
    }
}
