import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.*;
import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.*;

public class Aufgabe3Test {
    private static final List<String[]> inputsFood = new ArrayList<>();

    static {
        Random rand = new Random(4711);
        String[] food = new String[] {"Heu", "Drops", "Salat", "Spinat", "Sellerie", "Blumenkohl", "Brokkoli", "Fenchel", "Mais", "Karotte"};
        while (inputsFood.size() < 100) {
            int num = rand.nextInt(100)+1;
            String[] foodArr = new String[num];
            for (int i=0;i<num;i++) {
                foodArr[i] = food[rand.nextInt(food.length)];
            }
            inputsFood.add(foodArr);
        }
    }


    private static Stream<Arguments> getFoodTestInputArrays() {
        return inputsFood.stream().map(x -> Arguments.of((Object) x));
    }

    @ParameterizedTest
    @MethodSource("getFoodTestInputArrays")
    void futterSortieren(String[] input) {
        List<String> x = new ArrayList<>(Arrays.asList(input));
        Object[] expected = x.stream().map(Aufgabe3Utils::werIsst).sorted().toArray();

        Aufgabe3.futterSortieren(input);
        Object[] actual = Arrays.stream(input).map(Aufgabe3Utils::werIsst).toArray();

        assertArrayEquals(expected, actual);
    }
}
